#include <zlib.h>
#include <assert.h>
#include <string.h>
#include <dirent.h>
#include <vector>
#include <string>
#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <sys/stat.h>
#include <dir.h>
using namespace std;

typedef unsigned int u32;

const u32 VERSION = 0x10001000;

// make a file archive

void convertmapdata(const char *nameIn, const char *nameOut, bool pcByteOrder)
{
	unsigned long csize;
	FILE *f = fopen(nameIn, "rb");
    fseek (f, 0, SEEK_END);
    csize=ftell (f);
    fseek (f, 0, SEEK_SET);
	char *buf3 = new char[csize];
	fread(buf3, csize, 1, f);
	fclose(f);
	int u=0;
	int i=0;
	int o=0;
	unsigned long mdsize=18715;
	char *macdata = new char[mdsize];
	while(u*200<csize&&u<95) {
		i=0;
		while(i<197) {
			if(!pcByteOrder&&i==64) {
				macdata[(u*197)+i]=buf3[(u*200)+67];
			} else if(!pcByteOrder&&i==65) {
				macdata[(u*197)+i]=buf3[(u*200)+66];
			} else if(!pcByteOrder&&i==66) {
				macdata[(u*197)+i]=buf3[(u*200)+65];
			} else if(!pcByteOrder&&i==67) {
				macdata[(u*197)+i]=buf3[(u*200)+64];
			} else {
				macdata[(u*197)+i]=buf3[(u*200)+i];
			}
			i++;
		}
		//printf("%u, %u, %c\n",(u*200), i, macdata[(u*197)]);
		u++;
	}
	FILE *fo = fopen(nameOut,"wb");
	fwrite(macdata, 1, mdsize, fo);
	fclose(fo);
}
int main(int argc, char *argv[])
{
    convertmapdata("maps.dat","maps.dat.mac.0",false);
    convertmapdata("maps.dat","maps.dat.mac.1",true);
	printf("%s\n","File converted.");
	return 0;
}
